#ifndef __PERMUTATION_H__
#define __PERMUTATION_H__

typedef struct {
	int n;
	int* permutation;
} Permutation;

void initialise_to_first( Permutation* p );
Permutation* identity_permutation( int n);
Permutation* first_permutation( int n );
Permutation* next_permutation( Permutation* permutation );
void free_permutation( Permutation* permutation );

void print_permutation( Permutation* permutation );

#endif

