#include <MLV/MLV_all.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "geometrie.h"
#include "list.h"

void print_function( void* data ){
	printf("%s  -- ",(char*) data);
}

void* copy_data( void* data ){
	return (char*) strdup( (char*) data );
}

void change_data( void* data ){
	*((char*) data) = '@';
}

int main( int argc, char *argv[] ){
	List* l=NULL;
	l = add_before_data( l, "Bonjour" );
	l = add_before_data( l, "Il etait" );
	l = add_before_data( l, "Un fois" );
	l = add_before_data( l, "ha ha ha" );
	apply_function_data( l, &print_function );
	printf("\n");

	List* m=NULL;
	m = add_before_data( m, "4" );
	m = add_before_data( m, "3" );
	m = add_before_data( m, "2" );
	m = add_before_data( m, "1" );
	apply_function_data( m, &print_function );
	printf("\n");
	printf("\n");

	List* tmp = l->next;
	insert_after( tmp, m );

	apply_function_data( l, &print_function );
	printf("\n");
	apply_function_data( m, &print_function );
	printf("\n");

	printf("Taille l : %d\n", size_list(l));

	List* copy = deep_copy_list( l, &copy_data );
	apply_function_data( copy, &print_function );
	printf("\n");
	apply_function_data( copy, &change_data );
	apply_function_data( copy, &print_function );
	printf("\n");
	apply_function_data( l, &print_function );
	printf("\n");

	remove_from_list( copy->next );
	apply_function_data( copy, &print_function );
	printf("\n");

	
	
	free_list( l );

	return 0;
}

